---
title: WP Main Services
author:
date: 2024-03-01
...

# WP Main Services {#wp-main-services}

## plugins.wp.goal (`DATA`) {#goal}

Proof Obligations


> [`goal`](#goal)  `::=` `$wpo`
  

## plugins.wp.prover (`DATA`) {#prover}

Prover Identifier


> [`prover`](#prover)  `::=` `$prover`
  

## plugins.wp.result (`DATA`) {#result}

Prover Result


> [`result`](#result)  `::=` `{` `"descr"` `:` _string_ , `"cached"` `:`
  _boolean_ , `"verdict"` `:` _string_ , `"solverTime"` `:` _number_ ,
  `"proverTime"` `:` _number_ , `"proverSteps"` `:` _number_ `}`
  

## plugins.wp.status (`DATA`) {#status}

Test Status


> [`status`](#status)  `::=` `$NORESULT` | `$COMPUTING` | `$FAILED` |
  `$STEPOUT` | `$UNKNOWN` | `$VALID` | `$PASSED` | `$DOOMED`
  

## plugins.wp.stats (`DATA`) {#stats}

Prover Result


> [`stats`](#stats)  `::=` `{` `"summary"` `:` _string_ , `"tactics"` `:`
  _number_ , `"proved"` `:` _number_ , `"total"` `:` _number_ `}`
  

## plugins.wp.getAvailableProvers (`GET`) {#getavailableprovers}

Returns the list of configured provers from why3


> _input_ `::=` _null_
  

> _output_ `::=` [`prover`](index.md#prover)  `[]`
  

## plugins.wp.goals (`ARRAY`) {#goals}

Generated Goals


## plugins.wp.signalGoals (`SIGNAL`) {#signalgoals}

Signal for array [`goals`](#goals) 


## plugins.wp.goalsData (`DATA`) {#goalsdata}

Data for array rows [`goals`](#goals) 


> [`goalsData`](#goalsdata)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"wpo"` | [`goal`](index.md#goal)  | Entry identifier. |
| `"property"` | [`marker`](../../kernel/ast.md#marker)  | Property Marker |
| `"fct"` (opt.) | [`fct`](../../kernel/ast.md#fct)  | Associated function, if any |
| `"bhv"` (opt.) | _string_ | Associated behavior, if any |
| `"thy"` (opt.) | _string_ | Associated axiomatic, if any |
| `"name"` | _string_ | Informal Property Name |
| `"smoke"` | _boolean_ | Smoking (or not) goal |
| `"passed"` | _boolean_ | Valid or Passed goal |
| `"status"` | [`status`](index.md#status)  | Verdict, Status |
| `"stats"` | [`stats`](index.md#stats)  | Prover Stats Summary |
| `"script"` (opt.) | _string_ | Script File |
| `"saved"` | _boolean_ | Saved Script |


## plugins.wp.fetchGoals (`GET`) {#fetchgoals}

Data fetcher for array [`goals`](#goals) 


> _input_ `::=` _number_
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"reload"` | _boolean_ | array fully reloaded |
| `"removed"` | [`goal`](index.md#goal)  `[]` | removed entries |
| `"updated"` | [`goalsData`](index.md#goalsdata)  `[]` | updated entries |
| `"pending"` | _number_ | remaining entries to be fetched |


## plugins.wp.reloadGoals (`GET`) {#reloadgoals}

Force full reload for array [`goals`](#goals) 


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  

## plugins.wp.serverActivity (`SIGNAL`) {#serveractivity}

Proof Server Activity


## plugins.wp.getScheduledTasks (`GET`) {#getscheduledtasks}

Scheduled tasks in proof server


> _input_ `::=` _null_
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"procs"` | _number_ | Max parallel tasks |
| `"active"` | _number_ | Active tasks |
| `"done"` | _number_ | Finished tasks |
| `"todo"` | _number_ | Remaining jobs |


> _signals_
  

* `plugins.wp.serverActivity`


## plugins.wp.cancelProofTasks (`SET`) {#cancelprooftasks}

Cancel all scheduled proof tasks


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  