---
title: WP Interactive Prover
author:
date: 2024-03-01
...

# WP Interactive Prover {#wp-interactive-prover}

## plugins.wp.tip.proofStatus (`SIGNAL`) {#proofstatus}

Proof Status has changed


## plugins.wp.tip.getNodeInfos (`GET`) {#getnodeinfos}

Proof node information


> _input_ `::=` `#node`
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"result"` | _string_ | Proof node title |
| `"proved"` | _boolean_ | Proof node complete |
| `"pending"` | _number_ | Pending children |
| `"size"` | _number_ | Proof size |
| `"stats"` | _string_ | Node statistics |


> _signals_
  

* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.getProofState (`GET`) {#getproofstate}

Current Proof Status of a Goal


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"current"` | `#node` | Current proof node |
| `"parents"` | `#node` `[]` | Proof node parents |
| `"pending"` | _number_ | Pending proof nodes |
| `"index"` | _number_ | Current node index among pending nodes (else -1) |
| `"results"` | `[` [`prover`](index.md#prover)  , [`result`](index.md#result)  `]` `[]` | Prover results for current node |
| `"tactic"` | _string_ | Proof node tactic header (if any) |
| `"children"` | `[` _string_ , `#node` `]` `[]` | Proof node tactic children (id any) |


> _signals_
  

* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.goForward (`SET`) {#goforward}

Go to to first pending node, or root if none


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.goToRoot (`SET`) {#gotoroot}

Go to root of proof tree


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.goToIndex (`SET`) {#gotoindex}

Go to k-th pending node of proof tree


> _input_ `::=` `[` [`goal`](index.md#goal)  , _number_ `]`
  

> _output_ `::=` _null_
  

## plugins.wp.tip.goToNode (`SET`) {#gotonode}

Set current node of associated proof tree


> _input_ `::=` `#node`
  

> _output_ `::=` _null_
  

## plugins.wp.tip.removeNode (`SET`) {#removenode}

Remove node from tree and go to parent


> _input_ `::=` `#node`
  

> _output_ `::=` _null_
  

## plugins.wp.tip.printStatus (`SIGNAL`) {#printstatus}

Updated TIP printer


## plugins.wp.tip.iformat (`DATA`) {#iformat}

Integer constants format


> [`iformat`](#iformat)  `::=` `"dec"` | `"hex"` | `"bin"`
  

## plugins.wp.tip.rformat (`DATA`) {#rformat}

Real constants format


> [`rformat`](#rformat)  `::=` `"ratio"` | `"float"` | `"double"`
  

## plugins.wp.tip.printSequent (`EXEC`) {#printsequent}

Pretty-print the associated node


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` [`text`](../../kernel/data.md#text) 
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | `#node` | Proof Node |
| `"indent"` (opt.) | _number_ | Number of identation spaces |
| `"margin"` (opt.) | _number_ | Maximial text width |
| `"iformat"` (opt.) | [`iformat`](tip.md#iformat)  | Integer constants format |
| `"rformat"` (opt.) | [`rformat`](tip.md#rformat)  | Real constants format |
| `"autofocus"` (opt.) | _boolean_ | Auto-focus mode |
| `"unmangled"` (opt.) | _boolean_ | Unmangled memory model |


> _signals_
  

* `plugins.wp.tip.printStatus`


## plugins.wp.tip.clearSelection (`SET`) {#clearselection}

Reset node selection


> _input_ `::=` `#node`
  

> _output_ `::=` _null_
  

## plugins.wp.tip.setSelection (`SET`) {#setselection}

Set node selection


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` _null_
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | `#node` | Proof Node |
| `"part"` (opt.) | `$part` | Selected part |
| `"term"` (opt.) | `$term` | Selected term |
| `"extend"` (opt.) | _boolean_ | Extending selection mode |
